#include <stdio.h>
#include <time.h>

#ifdef USE_ALLEG
#include <allegro.h>
#endif

#include "globals.h"

/****************************
*							*
*		-D flags used:		*
*		DEBUGG				*
*		TIMEDEMO			*
*		TESTPPU				*
*		PR_DEB				*
*		PAL1				*
*							*
****************************/

void print_status ( )
{
	int tmp;
	tmp = ROM[ prose.ip ];
	printf ( "prose.a\t\t%.4X\t(%.5d)\t", prose.a, prose.a );
	printf ( "prose.x\t\t%.4X\t(%.5d)\n", prose.x, prose.x );
	printf ( "prose.y\t\t%.4X\t(%.5d)\t", prose.y, prose.y );
	printf ( "prose.stack\t%.4X\t(%.5d)\n", prose.stack, prose.stack );
	printf ( "prose.ip\t%.4X\t(%.5d)\t", prose.ip, prose.ip );
	printf ( "prose.clocks\t%.6X\t(%.5ld)\n", prose.clocks, prose.clocks );
	printf ( "CMD: %s / %.2x\t", cmd_tab[ tmp ].lexic, tmp );
	switch ( cmd_tab[ tmp ].size )
	{
		case 2:
				printf ( " %.2X\t\t(%d / %d)\n", ROM[prose.ip+1], ROM[prose.ip+1], ( signed char )ROM[prose.ip+1] );
				break;
		case 3:
				printf ( " %.4X\t(%d / %d)\t->\t%X\n", ( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ), ( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ), ( signed int )( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ), ROM[ ( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ) ] );
				break;
		default:
				printf ( "\n" );
				break;
	}
}

void print_status_lite ( )
{
	int tmp;
	tmp = ROM[ prose.ip ];
	printf ( "%.4X\t", prose.ip, prose.ip );
	printf ( "CMD: %s\t", cmd_tab[ tmp ].lexic, tmp );
	switch ( cmd_tab[ tmp ].size )
	{
		case 2:
				printf ( "%.2X\t(%d / %d)\n", ROM[prose.ip+1], ROM[prose.ip+1], ( signed char )ROM[prose.ip+1] );
				break;
		case 3:
				printf ( "%.4X\t(%d / %d)\t->\t%X\n", ( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ), ( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ), ( signed int )( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ), ROM[ ( ROM[prose.ip+2] << 8 ) + ( ROM[prose.ip+1] ) ] );
				break;
		default:
				printf ( "\n" );
				break;
	}
}

void print_smth ( )
{
	FILE *smth;
	int tmp;

	smth = fopen ( "smth.lst", "wt" );
	for ( tmp = 0; tmp < 0xFF; tmp++ )
	{
		fprintf ( smth, "%x\t", tmp );
		fprintf ( smth, "CMD: %s\t", cmd_tab[ tmp ].lexic );
		fprintf ( smth, "size: %d\t", cmd_tab[ tmp ].size );
		fprintf ( smth, "clocks: %d\n", cmd_tab[ tmp ].clocks );
		fflush ( smth );
	}
	fclose ( smth );
}

void dump_rom ( )
{
	FILE *rom_dump;
	rom_dump = fopen ( "romdump.bin", "wb" );
	fwrite ( ROM, 0x10000, 1, rom_dump );
	printf ( "ROM dump created..\n" );
	fclose ( rom_dump );
}

int main ( int argc, char *argv[] )
{
	//	Normal variables
	int running = 0;
	int breakcond, counter;
	unsigned int _end_tmp;
	int last_scanline, current_clocks;
	int sc_number = 0, old_clocks = 0;
	unsigned long sc_done = 0;

	clock_t start, end;
	double elapsed;
	unsigned long sc_total = 0;

#ifdef USE_ALLEG

	allegro_init ( );
	install_keyboard ( );
	_v_screen = create_bitmap_ex ( 8, 256, 240 );
	
	if ( set_gfx_mode ( GFX_AUTODETECT_WINDOWED, 512, 480, 0, 0 ) != 0 )
//	if ( set_gfx_mode ( GFX_SAFE, 320, 240, 0, 0 ) != 0 )
	{
		set_gfx_mode ( GFX_TEXT, 0, 0, 0, 0 );
		allegro_message ( "Can't set mode!" );
		return 1;
	}
	init_my_nes_pal ( );
	get_palette ( pal );

#endif

	if ( argv[1] != NULL )
	{
		nesfile = fopen ( argv[1], "rb" );
		if ( nesfile == NULL )
		{
				printf ( "\nFile opening failed.\n\nAre you sure that file (%s) exists?\n", argv[1] );
				return 0;
		}
		fileopen = 1;
	}
	else
	{
		printf ( "Usage: core2.exe [nesimage]\n" );
		return 0;
	}
	
	get_rom_info ( );

	printf ( "Mappler version: %d\n", rom_info.mm_version );

	init_none ( );
	init_none_ppu ( );

	reset_cpu ( );

#ifdef PR_DEB
	print_status ( );
#endif

#ifndef DEBUGG
	breakcond = getch ( );
	if ( breakcond == 'q' )
		running = 1;
	if ( breakcond == 'd' )
		dump_rom ( );
	if ( breakcond == 'f' )
		dump_ppu ( );
	if ( breakcond == 'g' )
	{
		dump_ppu ( );
		dump_rom ( );
	}
#endif
	
	fflush ( stdin );

#ifdef TESTPPU
	ROM[ 0x2002 ] = 0x80;	//	To get past vblank
	ppuStatus = 0x80;
#endif

	start = clock();

	while ( running == 0 )			//		Main Loop begins here
//	while ( !keypressed ( ) )
	{
		exec ( );

		if ( ( prose.clocks - old_clocks ) >= 341 )
		{
//			printf ( "Scanline nr. %d ( %d ) Ticks = %d\n", sc_number, sc_done++, prose.clocks );
			do_bg_scanline ( sc_number );
			sc_number++;
			if ( sc_number > 239 )
			{
				sc_number = 0;
				NMI ( );	//	Saving processor regs and stuff and doing NMI routine
				test_sprite_func ( );
				stretch_blit ( _v_screen, screen, 0, 0, 256, 240, 0, 0, 512, 480 );
//				clear_to_color ( _v_screen, 213 );
				sc_total++;
				if ( keypressed ( ) )
					running = 1;
			}
			old_clocks = prose.clocks;
		}

#ifdef PR_DEB
		print_status ( );
#endif
	
#ifndef DEBUGG
		breakcond = getch ( );
		if ( breakcond == 'q' )
			running = 1;
		if ( breakcond == 'd' )
			dump_rom ( );
		if ( breakcond == 'f' )
			dump_ppu ( );
		if ( breakcond == 'g' )
		{
			dump_ppu ( );
			dump_rom ( );
		}
#endif
	}								//		Main loop
	end = clock();
	elapsed = ((double) (end - start)) / CLOCKS_PER_SEC;
	printf ( "Aega kulus: %f\tFreime oli %d\nFPS:\t%f\n", elapsed, sc_total, ( double )( sc_total / elapsed ) );
#ifdef USE_ALLEG
	set_palette ( pal );
	for ( ; sc_number < 240; sc_number++ )
		do_bg_scanline ( sc_number );
	stretch_blit ( _v_screen, screen, 0, 0, 256, 240, 0, 0, 512, 480 );
	save_bmp ( "screenshot.bmp", _v_screen, pal );
	dump_ppu ( );
	dump_rom ( );
#endif
	if ( fileopen == 1 )
	{
		fclose ( nesfile );
		fileopen = 0;
	}
	return 0;
}

#ifdef USE_ALLEG
END_OF_MAIN();
#endif
