#include <stdio.h>

#ifdef USE_ALLEG
#include <allegro.h>
#endif

#include "globals.h"

//	lexic, size, clock, add_fun, fun

const CMD cmd_tab[ ] = {
{	"BRK",	1,	7,	implied,		j6502_brk },	//	0x00	BRK
{	"ORA",	2,	6,	indexed_x,		j6502_ora	},	//	0x01	ORA	(zp,X)
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x02	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x03	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x04	--
{	"ORA",	2,	3,	zeropage,		j6502_ora	},	//	0x05	ORA	zp
{	"ASL",	2,	5,	zeropage,		j6502_asl	},	//	0x06	ASL	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x07	--
{	"PHP",	1,	3,	implied,		j6502_php	},	//	0x08	PHP
{	"ORA",	2,	2,	immediate,		j6502_ora	},	//	0x09	ORA	#aa
{	"ASL",	1,	2,	implied,		j6502_asl	},	//	0x0A	ASL	A
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x0B	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x0C	--
{	"ORA",	3,	4,	absolute,		j6502_ora	},	//	0x0D	ORA	$aaaa
{	"ASL",	3,	6,	absolute,		j6502_asl	},	//	0x0E	ASL	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x0F	--
{	"BPL",	2,	2,	relative,		j6502_bpl	},	//	0x10	BPL	rel
{	"ORA",	2,	5,	indexed_y,		j6502_ora	},	//	0x11	ORA	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x12	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x13	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x14	--
{	"ORA",	2,	4,	zp_index_x,		j6502_ora	},	//	0x15	ORA zp,X
{	"ASL",	2,	6,	zp_index_x,		j6502_asl	},	//	0x16	ASL	zp,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x17	--
{	"CLC",	1,	2,	implied,		j6502_clc	},	//	0x18	CLC
{	"ORA",	3,	4,	abs_index_y,	j6502_ora	},	//	0x19	ORA	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x1A	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x1B	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x1C	--
{	"ORA",	3,	4,	abs_index_x,	j6502_ora	},	//	0x1D	ORA	$aaaa,X
{	"ASL",	3,	6,	abs_index_x,	j6502_asl	},	//	0x1E	ASL	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x1F	--
{	"JSR",	3,	6,	absolute,		j6502_jsr	},	//	0x20	JSR	$aaaa
{	"AND",	2,	6,	indexed_x,		j6502_and	},	//	0x21	AND	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x22	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x23	--
{	"BIT",	2,	3,	zeropage,		j6502_bit	},	//	0x24	BIT	zp
{	"AND",	2,	3,	zeropage,		j6502_and	},	//	0x25	AND	zp
{	"ROL",	2,	5,	zeropage,		j6502_rol	},	//	0x26	ROL	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x27	--
{	"PLP",	1,	4,	implied,		j6502_plp	},	//	0x28	PLP
{	"AND",	2,	2,	immediate,		j6502_and	},	//	0x29	AND	#aa
{	"ROL",	1,	2,	implied,		j6502_rol	},	//	0x2A	ROL A
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x2B	--
{	"BIT",	3,	4,	absolute,		j6502_bit	},	//	0x2C	BIT $aaaa
{	"AND",	3,	4,	absolute,		j6502_and	},	//	0x2D	AND $aaaa
{	"ROL",	3,	6,	absolute,		j6502_rol	},	//	0x2E	ROL	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x2F	--
{	"BMI",	2,	2,	relative,		j6502_bmi	},	//	0x30	BMI	rel
{	"AND",	2,	5,	indexed_y,		j6502_and	},	//	0x31	AND (zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x32	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x33	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x34	--
{	"AND",	2,	4,	indexed_x,		j6502_and	},	//	0x35	AND	(zp),X
{	"ROL",	2,	6,	indexed_x,		j6502_rol	},	//	0x36	ROL	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x37	--
{	"SEC",	1,	2,	implied,		j6502_sec	},	//	0x38	SEC
{	"AND",	3,	4,	abs_index_y,	j6502_and	},	//	0x39	AND	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x3A	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x3B	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x3C	--
{	"AND",	3,	4,	abs_index_x,	j6502_and	},	//	0x3D	AND	$aaaa,X
{	"ROL",	3,	6,	abs_index_x,	j6502_rol	},	//	0x3E	ROL	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x3F	--
{	"RTI",	1,	6,	implied,		j6502_rti	},	//	0x40	RTI
{	"EOR",	2,	6,	indexed_x,		j6502_eor	},	//	0x41	EOR	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x42	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x43	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x44	--
{	"EOR",	2,	3,	zeropage,		j6502_eor	},	//	0x45	EOR	zp
{	"LSR",	2,	5,	zeropage,		j6502_lsr	},	//	0x46	LSR	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x47	--
{	"PHA",	1,	3,	implied,		j6502_pha	},	//	0x48	PHA
{	"EOR",	2,	2,	immediate,		j6502_eor	},	//	0x49	EOR #aa
{	"LSR",	1,	2,	implied,		j6502_lsr	},	//	0x4A	LSR	A
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x4B	--
{	"JMP",	3,	3,	absolute,		j6502_jmp	},	//	0x4C	JMP	$aaaa
{	"EOR",	3,	4,	absolute,		j6502_eor	},	//	0x4D	EOR	$aaaa
{	"LSR",	3,	6,	absolute,		j6502_lsr	},	//	0x4E	LSR	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x4F	--
{	"BVC",	2,	2,	relative,		j6502_bvc	},	//	0x50	BVC	rel
{	"EOR",	2,	5,	indexed_y,		j6502_eor	},	//	0x51	EOR	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x52	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x53	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x54	--
{	"EOR",	2,	4,	indexed_x,		j6502_eor	},	//	0x55	EOR	(zp),X
{	"LSR",	2,	6,	indexed_x,		j6502_lsr	},	//	0x56	LSR	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x57	--
{	"CLI",	1,	2,	implied,		j6502_cli	},	//	0x58	CLI
{	"EOR",	3,	4,	abs_index_y,	j6502_eor	},	//	0x59	EOR	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x5A	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x5B	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x5C	--
{	"EOR",	3,	4,	abs_index_x,	j6502_eor	},	//	0x5D	EOR	$aaaa,X
{	"LSR",	3,	6,	abs_index_x,	j6502_lsr	},	//	0x5E	LSR	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x5F	--
{	"RTS",	1,	6,	implied,		j6502_rts	},	//	0x60	RTS
{	"ADC",	2,	6,	indexed_x,		j6502_adc	},	//	0x61	ADC	(xp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x62	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x63	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x64	--
{	"ADC",	2,	4,	zeropage,		j6502_adc	},	//	0x65	ADC	zp
{	"ROR",	2,	5,	zeropage,		j6502_ror	},	//	0x66	ROR	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x67	--
{	"PLA",	1,	4,	implied,		j6502_pla	},	//	0x68	PLA
{	"ADC",	2,	2,	immediate,		j6502_adc	},	//	0x69	ADC	#aa
{	"ROR",	1,	2,	implied,		j6502_ror	},	//	0x6A	ROR A
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x6B	--
{	"JMP",	3,	6,	jmp_indirect,	j6502_jmp	},	//	0x6C	JMP ($aaaa)
{	"ADC",	3,	4,	absolute,		j6502_adc	},	//	0x6D	ADC	$aaaa
{	"ROR",	3,	6,	absolute,		j6502_ror	},	//	0x6E	ROR	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x6F	--
{	"BVS",	2,	2,	relative,		j6502_bvs	},	//	0x70	BVS	rel
{	"ADC",	2,	5,	indexed_y,		j6502_adc	},	//	0x71	ADC	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x72	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x73	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x74	--
{	"ADC",	2,	4,	indexed_x,		j6502_adc	},	//	0x75	ADC	(zp),X
{	"ROR",	2,	6,	indexed_x,		j6502_ror	},	//	0x76	ROR	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x77	--
{	"SEI",	1,	2,	implied,		j6502_sei	},	//	0x78	SEI
{	"ADC",	3,	4,	abs_index_y,	j6502_adc	},	//	0x79	ADC	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x7A	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x7B	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x7C	--
{	"ADC",	3,	4,	abs_index_x,	j6502_adc	},	//	0x7D	ADC	$aaaa,X
{	"ROR",	3,	6,	abs_index_x,	j6502_ror	},	//	0x7E	ROR	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x7F	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x80	--	//	BRA rel
{	"STA",	2,	6,	indexed_x,		j6502_sta	},	//	0x81	STA	($aa),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x82	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x83	--
{	"STY",	2,	3,	zeropage,		j6502_sty	},	//	0x84	STY	zp
{	"STA",	2,	3,	zeropage,		j6502_sta	},	//	0x85	STA	zp
{	"STX",	2,	3,	zeropage,		j6502_stx	},	//	0x86	STX	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x87	--
{	"DEY",	1,	2,	implied,		j6502_dey	},	//	0x88	DEY
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x89	--
{	"TXA",	1,	2,	implied,		j6502_txa	},	//	0x8A	TXA
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x8B	--
{	"STY",	3,	4,	absolute,		j6502_sty	},	//	0x8C	STY	$aaaa
{	"STA",	3,	4,	absolute,		j6502_sta	},	//	0x8D	STA	$aaaa
{	"STX",	3,	4,	absolute,		j6502_stx	},	//	0x8E	STX	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x8F	--
{	"BCC",	2,	2,	relative,		j6502_bcc	},	//	0x90	BCC rel
{	"STA",	2,	6,	indexed_y,		j6502_sta	},	//	0x91	STA ($aa),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x92	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x93	--
{	"STY",	2,	4,	indexed_x,		j6502_sty	},	//	0x94	STY	(zp),X
{	"STA",	2,	4,	indexed_x,		j6502_sta	},	//	0x95	STA	(zp),X
{	"STX",	2,	4,	indexed_y,		j6502_sty	},	//	0x96	STX	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x97	--
{	"TYA",	1,	2,	implied,		j6502_tya	},	//	0x98	TYA
{	"STA",	3,	5,	abs_index_y,	j6502_sta	},	//	0x99	STA $aaaa,Y
{	"TXS",	1,	2,	implied,		j6502_txs	},	//	0x9A	TXS
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x9B	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x9C	--
{	"STA",	3,	5,	abs_index_x,	j6502_sta	},	//	0x9D	STA	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x9E	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0x9F	--
{	"LDY",	2,	2,	immediate,		j6502_ldy	},	//	0xA0	LDY	#aa
{	"LDA",	2,	6,	indexed_x,		j6502_lda	},	//	0xA1	LDA	(zp),X
{	"LDX",	2,	2,	immediate,		j6502_ldx	},	//	0xA2	LDX	#aa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xA3	--
{	"LDY",	2,	3,	zeropage,		j6502_ldy	},	//	0xA4	LDY	zp
{	"LDA",	2,	3,	zeropage,		j6502_lda	},	//	0xA5	LDA	zp
{	"LDX",	2,	3,	zeropage,		j6502_ldx	},	//	0xA6	LDX	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xA7	--
{	"TAY",	1,	2,	implied,		j6502_tay	},	//	0xA8	TAY
{	"LDA",	2,	2,	immediate,		j6502_lda	},	//	0xA9	LDA	#aa
{	"TAX",	1,	2,	implied,		j6502_tax	},	//	0xAA	TAX
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xAB	--
{	"LDY",	3,	4,	absolute,		j6502_ldy	},	//	0xAC	LDY	$aaaa
{	"LDA",	3,	4,	absolute,		j6502_lda	},	//	0xAD	LDA	$aaaa
{	"LDX",	3,	4,	absolute,		j6502_lda	},	//	0xAE	LDX	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xAF	--
{	"BCS",	2,	2,	relative,		j6502_bcs	},	//	0xB0	BCS	rel
{	"LDA",	2,	5,	indexed_y,		j6502_lda	},	//	0xB1	LDA	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xB2	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xB3	--
{	"LDY",	2,	4,	indexed_x,		j6502_ldy	},	//	0xB4	LDY	(zp),X
{	"LDA",	2,	4,	indexed_x,		j6502_lda	},	//	0xB5	LDA	(zp),X
{	"LDX",	2,	4,	indexed_y,		j6502_ldx	},	//	0xB6	LDX	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xB7	--
{	"CLV",	1,	2,	implied,		j6502_clv	},	//	0xB8	CLV
{	"LDA",	3,	4,	abs_index_y,	j6502_lda	},	//	0xB9	LDA	$aaaa,Y
{	"TSX",	2,	1,	implied,		j6502_tsx	},	//	0xBA	TSX
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xBB	--
{	"LDY",	3,	4,	abs_index_x,	j6502_ldy	},	//	0xBC	LDY	$aaaa,X
{	"LDA",	3,	4,	abs_index_x,	j6502_lda	},	//	0xBD	LDA	$aaaa,X
{	"LDX",	3,	4,	abs_index_y,	j6502_ldx	},	//	0xBE	LDX	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xBF	--
{	"CPY",	2,	2,	immediate,		j6502_cpy	},	//	0xC0	CPY	#aa
{	"CMP",	2,	6,	indexed_x,		j6502_cmp	},	//	0xC1	CMP	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xC2	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xC3	--
{	"CPY",	2,	3,	zeropage,		j6502_cpy	},	//	0xC4	CPY	zp
{	"CMP",	2,	3,	zeropage,		j6502_cmp	},	//	0xC5	CMP	zp
{	"DEC",	2,	5,	zeropage,		j6502_dec	},	//	0xC6	DEC	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xC7	--
{	"INY",	1,	2,	implied,		j6502_iny	},	//	0xC8	INY
{	"CMP",	2,	2,	immediate,		j6502_cmp	},	//	0xC9	CMP	#aa
{	"DEX",	1,	2,	implied,		j6502_dex	},	//	0xCA	DEX
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xCB	--
{	"CPY",	3,	4,	absolute,		j6502_cpy	},	//	0xCC	CPY	$aaaa
{	"CMP",	3,	4,	absolute,		j6502_cmp	},	//	0xCD	CMP	$aaaa
{	"DEC",	3,	6,	absolute,		j6502_dec	},	//	0xCE	DEC	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xCF	--
{	"BNE",	2,	2,	relative,		j6502_bne	},	//	0xD0	BNE	rel
{	"CMP",	2,	5,	indexed_y,		j6502_cmp	},	//	0xD1	CMP	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xD2	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xD3	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xD4	--
{	"CMP",	2,	3,	indexed_x,		j6502_cmp	},	//	0xD5	CMP	(zp),X
{	"DEC",	2,	6,	indexed_x,		j6502_dec	},	//	0xD6	DEC	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xD7	--
{	"CLD",	1,	2,	implied,		j6502_cld	},	//	0xD8	CLD
{	"CMP",	3,	4,	abs_index_y,	j6502_cmp	},	//	0xD9	CMP	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xDA	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xDB	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xDC	--
{	"CMP",	3,	4,	abs_index_x,	j6502_cmp	},	//	0xDD	CMP	$aaaa,X
{	"DEC",	3,	6,	abs_index_x,	j6502_dec	},	//	0xDE	DEC	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xDF	--
{	"CPX",	2,	2,	immediate,		j6502_cpx	},	//	0xE0	CPX	#aa
{	"SBC",	2,	6,	indexed_x,		j6502_sbc	},	//	0xE1	SBC	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xE2	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xE3	--
{	"CPX",	2,	3,	zeropage,		j6502_cpx	},	//	0xE4	CPX	zp
{	"SBC",	2,	3,	zeropage,		j6502_sbc	},	//	0xE5	SBC	zp
{	"INC",	2,	5,	zeropage,		j6502_inc	},	//	0xE6	INC	zp
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xE7	--
{	"INX",	1,	2,	implied,		j6502_inx	},	//	0xE8	INX
{	"SBC",	2,	2,	immediate,		j6502_sbc	},	//	0xE9	SBC	#aa
{	"NOP",	1,	2,	implied,		j6502_nop	},	//	0xEA	NOP
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xEB	--
{	"CPX",	3,	4,	absolute,		j6502_cpx	},	//	0xEC	CPX	$aaaa
{	"SBC",	3,	4,	absolute,		j6502_sbc	},	//	0xED	SBC	$aaaa
{	"INC",	3,	6,	absolute,		j6502_inc	},	//	0XEE	INC	$aaaa
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xEF	--
{	"BEQ",	2,	2,	relative,		j6502_beq	},	//	0xF0	BEQ	rel
{	"SBC",	2,	5,	indexed_y,		j6502_sbc	},	//	0xF1	SBC	(zp),Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xF2	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xF3	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xF4	--
{	"SBC",	2,	4,	indexed_x,		j6502_sbc	},	//	0XF5	SBC	(zp),X
{	"INC",	2,	6,	indexed_x,		j6502_inc	},	//	0xF6	INC	(zp),X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xF7	--
{	"SED",	2,	1,	immediate,		j6502_sed	},	//	0xF8	SED	#aa
{	"SBC",	3,	4,	abs_index_y,	j6502_sbc	},	//	0xF9	SBC	$aaaa,Y
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xFA	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xFB	--
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xFC	--
{	"SBC",	3,	4,	abs_index_x,	j6502_sbc	},	//	0xFD	SBC	$aaaa,X
{	"INC",	3,	6,	abs_index_x,	j6502_inc	},	//	0xFE	INC	$aaaa,X
{	"BAD",	1,	2,	implied,		j6502_bad	},	//	0xFF	--
};


int exec ( )
{
	int code;
	code = ROM[ prose.ip ];
	( cmd_tab[ code ].handler ) ( code, cmd_tab[ code ].clocks, ( cmd_tab[ code ].add_fun ) );
	return 0;
}
