#include <stdio.h>

#ifdef USE_ALLEG
#include <allegro.h>
#endif

#include "globals.h"

#ifdef USE_ALLEG
#ifdef PAL1
RGB nes_pal[64] = 
{
{	117,	117,	117	},
{	39,		27,		143 },
{	0,		0,		171	},
{	71,		0,		159	},
{	143,	0,		119	},
{	171,	0,		19	},
{	167,	0,		0	},
{	127,	11,		0	},
{	67,		47,		0	},
{	0,		71,		0	},//10
{	0,		81,		0	},
{	0,		63,		23	},
{	27,		63,		95	},
{	0,		0,		0	},
{	0,		0,		0	},
{	0,		0,		0	},
{	188,	188,	188	},
{	0,		115,	239	},
{	35,		59,		239	},
{	131,	0,		243	},//20
{	191,	0,		191	},
{	231,	0,		91	},
{	219,	43,		0	},
{	203,	79,		15	},
{	139,	115,	0	},
{	0,		151,	0	},
{	0,		171,	0	},
{	0,		147,	59	},
{	0,		131,	139	},
{	0,		0,		0	},//30
{	0,		0,		0	},
{	0,		0,		0	},
{	255,	255,	255	},
{	63,		191,	255	},
{	95,		151,	255	},
{	167,	139,	253	},
{	247,	123,	255	},
{	255,	119,	183	},
{	255,	119,	99	},
{	255,	155,	59	},//40
{	243,	191,	63	},
{	131,	211,	19	},
{	79,		223,	75	},
{	88,		248,	152	},
{	0,		235,	219	},
{	0,		0,		0	},
{	0,		0,		0	},
{	0,		0,		0	},
{	255,	255,	255	},
{	171,	231,	255	},//50
{	199,	215,	255	},
{	215,	203,	255	},
{	255,	199,	255	},
{	255,	199,	219	},
{	255,	191,	179	},
{	255,	219,	171	},
{	255,	231,	163	},
{	227,	255,	163	},
{	171,	243,	191	},
{	179,	255,	207	},//60
{	159,	255,	243	},
{	0,		0,		0	},
{	0,		0,		0	},
{	0,		0,		0	},
};
#else
RGB nes_pal[64] =
{
   {0x80,0x80,0x80}, {0x00,0x00,0xBB}, {0x37,0x00,0xBF}, {0x84,0x00,0xA6},
   {0xBB,0x00,0x6A}, {0xB7,0x00,0x1E}, {0xB3,0x00,0x00}, {0x91,0x26,0x00},
   {0x7B,0x2B,0x00}, {0x00,0x3E,0x00}, {0x00,0x48,0x0D}, {0x00,0x3C,0x22},
   {0x00,0x2F,0x66}, {0x00,0x00,0x00}, {0x05,0x05,0x05}, {0x05,0x05,0x05},

   {0xC8,0xC8,0xC8}, {0x00,0x59,0xFF}, {0x44,0x3C,0xFF}, {0xB7,0x33,0xCC},
   {0xFF,0x33,0xAA}, {0xFF,0x37,0x5E}, {0xFF,0x37,0x1A}, {0xD5,0x4B,0x00},
   {0xC4,0x62,0x00}, {0x3C,0x7B,0x00}, {0x1E,0x84,0x15}, {0x00,0x95,0x66},
   {0x00,0x84,0xC4}, {0x11,0x11,0x11}, {0x09,0x09,0x09}, {0x09,0x09,0x09},

   {0xFF,0xFF,0xFF}, {0x00,0x95,0xFF}, {0x6F,0x84,0xFF}, {0xD5,0x6F,0xFF},
   {0xFF,0x77,0xCC}, {0xFF,0x6F,0x99}, {0xFF,0x7B,0x59}, {0xFF,0x91,0x5F},
   {0xFF,0xA2,0x33}, {0xA6,0xBF,0x00}, {0x51,0xD9,0x6A}, {0x4D,0xD5,0xAE},
   {0x00,0xD9,0xFF}, {0x66,0x66,0x66}, {0x0D,0x0D,0x0D}, {0x0D,0x0D,0x0D},

   {0xFF,0xFF,0xFF}, {0x84,0xBF,0xFF}, {0xBB,0xBB,0xFF}, {0xD0,0xBB,0xFF},
   {0xFF,0xBF,0xEA}, {0xFF,0xBF,0xCC}, {0xFF,0xC4,0xB7}, {0xFF,0xCC,0xAE},
   {0xFF,0xD9,0xA2}, {0xCC,0xE1,0x99}, {0xAE,0xEE,0xB7}, {0xAA,0xF7,0xEE},
   {0xB3,0xEE,0xFF}, {0xDD,0xDD,0xDD}, {0x11,0x11,0x11}, {0x11,0x11,0x11}
};
#endif	//	PAL1
#endif	//	USE_ALLEG

unsigned int ppuAddressOld = 0x2000;
unsigned int ppuAddressNew = 0x2000;
unsigned int ppuControl1 = 0x00;
unsigned int ppuControl2 = 0x00;
unsigned int ppuStatus = 0x00;
unsigned int ppuAddressHigh = 0x00;

__inline__ void write_ppu ( unsigned int _ppu_addr, unsigned char _ppu_val )
{
	int _tmp_cntr;
	if ( _ppu_addr == 0x2000 )			//	0x2000
	{
		ppuControl1 = _ppu_val;
		ROM[ _ppu_addr ] = _ppu_val;
		return;
	}
	if ( _ppu_addr == 0x2001 )			//	0x2001
	{
		ppuControl2 = _ppu_val;
		ROM[ _ppu_addr ] = _ppu_val;
		return;
	}
	if ( _ppu_addr == 0x2003 )			//	0x2003
	{
//		sprAddress = _ppu_val;
		prose.spr_addr = _ppu_val;
		ROM[ _ppu_addr ] = _ppu_val;
		return;
	}
	if ( _ppu_addr == 0x2004 )			//	0x2004
	{
//		sprMem[sprAddress] = _ppu_val;	//	Sprite stuff
		SPR[ prose.spr_addr ] = _ppu_val;
		prose.spr_addr++;
		ROM[ _ppu_addr ] = _ppu_val;
		return;
	}
	if ( _ppu_addr == 0x2006 )
	{
		if ( ppuAddressHigh == 0x00 )
		{
			ppuAddressNew = ( _ppu_val << 8 );
#ifdef PR_DEB
			printf ( "Address high = %X\n", ppuAddressNew );
#endif
			ppuAddressHigh = 0x01;
			return;
		}
		if ( ppuAddressHigh == 0x01 )
		{
			ppuAddressNew += _ppu_val;
#ifdef PR_DEB
			printf ( "Whole address = %X\n", ppuAddressNew );
#endif
			ppuAddressHigh = 0x00;
			return;
		}
	}
	if ( _ppu_addr == 0x2007 )
	{
		PPU[ ppuAddressNew ] = _ppu_val;
		ppuAddressOld = ppuAddressNew;
		if ( ( ppuControl1 & 0x04 ) == 0 )
			ppuAddressNew++;
		else
			ppuAddressNew += 0x20;
		ROM[ _ppu_addr ] = _ppu_val;
		return;
	}
	if ( _ppu_addr == 0x4014 )
	{
//		memcpy ( SPR, ROM[ 0x100 * _ppu_val ], 0xFF );
		for ( _tmp_cntr = 0; _tmp_cntr < 0xFF; _tmp_cntr++ )
			SPR[ _tmp_cntr ] = ROM [ 0x100 * _ppu_val + _tmp_cntr ];
	}
	return;
}

void dump_ppu ( )
{
	FILE *ppu_dump;
	ppu_dump = fopen ( "ppudump.bin", "wb" );
	fwrite ( PPU, 0x10000, 1, ppu_dump );
	printf ( "PPU dump created..\n" );
	fclose ( ppu_dump );
	ppu_dump = fopen ( "spr_mem.bin", "wb" );
	fwrite ( SPR, 0x100, 1, ppu_dump );
	printf ( "SPR dump created..\n" );
	fclose ( ppu_dump );
}

void exec_ppu ( )
{
}

#ifdef USE_ALLEG
void do_bg_scanline ( unsigned int _sc_nr )
{
	int tile_nr, tile_nr32;
	int chr_nr, chr_nr4;
	int line_nr;
	int attrib_magic;
	int counter, buf_cnt;
	int att_tmp1, att_tmp2, shft_step;	//	for attrib table
	unsigned char buffer[8];
	tile_nr = _sc_nr >> 3;					// ( _sc_nr / 8 )
	tile_nr32 = tile_nr << 5;				//	( tile_nr * 32 )
	line_nr = _sc_nr % 8;
	attrib_magic = ( _sc_nr >> 5 ) << 3;	// ( _sc_nr / 32 ) * 8
	for ( counter = 0; counter < 32; counter++ )
	{
		chr_nr = PPU[ 0x2000 + ( tile_nr32 ) + counter ];
		chr_nr4 = chr_nr << 4;
// First pass (lower bit)
		for ( buf_cnt = 7; buf_cnt >= 0; buf_cnt-- )
		{
			buffer[ 7 - buf_cnt ] = ( PPU[ chr_nr4 + line_nr ] >> buf_cnt ) & 0x01;
		}
//	Second pass (2. bit)
		for ( buf_cnt = 7; buf_cnt >= 0; buf_cnt-- )
		{
			buffer[ 7 - buf_cnt ] += ( ( PPU[ chr_nr4 + line_nr + 8 ] >> buf_cnt ) & 0x01) << 1;
		}
//	Third pass (3. and 4. bit)
		att_tmp1 = PPU[ 0x23C0 + attrib_magic + ( counter >> 2 ) ];
		att_tmp2 = ( ( ( tile_nr % 4 ) > 1 ) ? 2 : 0 );
		shft_step = ( ( counter >> 1 ) % 2 );
//		printf ( "%X ", ( tile_nr ) % 4 );		//	Debugg
		for ( buf_cnt = 7; buf_cnt >= 0; buf_cnt-- )
		{
			buffer[ 7 - buf_cnt ] += ( ( ( att_tmp1 >> ( shft_step + att_tmp2 ) ) & 0x03 ) << 0x02 );
		}
//	Blit must happen here
		for ( buf_cnt = 0; buf_cnt < 8; buf_cnt++ )
		{
			_putpixel ( _v_screen, ( counter << 3 ) + buf_cnt, _sc_nr, PPU[  0x3F00 + buffer[ buf_cnt ] ] );
//			putpixel ( _v_screen, counter * 8 + buf_cnt, _sc_nr, buffer[ buf_cnt ] );
//			printf ( "%X ", PPU[  0x3F00 + buffer[ buf_cnt ] ] );	// Debugg
		}
	}
//	printf ( "\n" );	// Debugg
}

void init_my_nes_pal ( )
{
	int a;
	RGB tmp_color;

/*
	for ( a = 0; a < 64; a++ )
		set_color ( a, &( nes_pal[ a ] ) );
*/

	FILE *f_nes_pal;
	f_nes_pal = fopen ( "nesticle.pal", "rb" );
	if ( ( f_nes_pal = fopen ( "nesticle.pal", "rb" ) ) == NULL )
	{
		printf ( "Error opening Nesticle(tm) pal!\n" );
		exit ( 0 );
	}
	for ( a = 0; a < 64; a++ )
	{
		tmp_color.r = getc ( f_nes_pal );
		tmp_color.g = getc ( f_nes_pal );
		tmp_color.b = getc ( f_nes_pal );
		set_color ( a, &tmp_color );
	}
	fclose ( f_nes_pal );

}

void test_sprite_func ( )
{
	int counter;
	BITMAP *spr_bit_map;
	spr_bit_map = create_bitmap ( 8, 8 );
	for ( counter = 0; counter < 64; counter++ )
	{
		clear_to_color ( spr_bit_map, counter );
		if ( SPR[ counter * 4 ] == 0 )
			continue;
		else
			draw_sprite ( _v_screen, spr_bit_map, SPR[ counter * 4 + 3 ], SPR[ counter * 4 ] );
	}
}

#endif
